/// @file
/// A TLM task.

#include <sstream>
#include "MyTaskReceiver.hh"




// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

MyTaskReceiver::MyTaskReceiver( sc_core::sc_module_name modulename,
                                const task_id_t id,
                                Scnsl::Core::Node_t * n,
                                const size_t proxies )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Rtl::RtlTask_if_t<8>( modulename, id, n, proxies )
{
	SC_THREAD( readingProcess );
	sensitive << newInputPacket[0];

	SC_THREAD( carrierProcess );
	sensitive << carrier[0];
}


void MyTaskReceiver::readingProcess()
{
	while( true )
 	{
		wait();

		sc_dt::sc_uint<8> data = inputPacket[0].read();
		byte_t b = byte_t( data );

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data received: " << b;
		std::cout << ", packet size: " << inputPacketSize[0].read()/8 << " bytes, label: " << inputPacketLabel[0].read() << std::endl;
	}

}

void MyTaskReceiver::carrierProcess()
{
	while ( true )
	{
		wait();
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", carrier: " << carrier[0].read() << std::endl;
	}
}
